/// class PD.Manage.Modules.DocumentTypes

PD.Manage.Modules.DocumentTypes =
PD.Manage.Module.extend({

    //===================================
    // FIELDS
    //===================================

    _grid: null,
    _toolbar: null,

    //===================================
    // EVENT HANDLERS
    //===================================

    onInit: function () {

        var that = this;

        this.subscriptions.add("document-type/create", function (e) {
            that._grid.refresh({
                clear: true,
                selections: [e.id]
            });
        });

        this.subscriptions.add("document-type/edit", function () {
            that._grid.refresh();
        });

        this.subscriptions.add("document-type/delete", function () {
            that._grid.refresh({
                clear: true
            });
        });

    },

    onActivate: function (e) {
        this.data("hasToolbar", false);
        this._grid_init();
        this._toolbar_init();
    },

    prepare: function () {

        var that = this;

        PD.ajax({
            url: PD.Path.resolve("~/Manage/DocumentTypes"),
            success: function (data) {
                that.data("viewStateId", data.viewStateId);
                that.data("entityTypeId", data.entityTypeId);
                that.ready();
            },
            error: function (e) {
                that.error();
                e.errorHandled = true;
            }
        });

    },

    //===================================
    // PROTECTED METHODS
    //===================================

    template: function (e) {
        return [
            "<div style='position:absolute;top:0;left:0;bottom:0;right:0;overflow:hidden;'>",
                "<div data-id='toolbar' style='position:absolute;height:30px;top:10px;left:10px;right:10px;'>",
                "</div>",
                "<div data-id='grid' style='position:absolute;top:50px;left:10px;bottom:10px;right:10px;border:1px solid #DDDDDD;'>",
                "</div>",
            "</div>"
        ];
    },

    focus: function () {
        this._super();
        this._grid.redraw();
    },

    //===================================
    // PRIVATE METHODS
    //===================================

    _grid_init: function () {

        var that = this;

        this._grid = new PD.Web.UI.Controls.ViewGrid({
            insertAt: "[data-id=grid]",
            viewStateId: this.data("viewStateId"),
            selectOnRightClick: true,
            selection: {
                map: function (e) {
                    return _.map(e.selections.toArray(), function (item, index) {
                        return {
                            id: item.ObjectId,
                            name: item.Name,
                            canvasId: item.CanvasId
                        };
                    });
                }
            },
            change: function (e) {

                var documentType = _.first(e.selections.toArray());

                PD.context.get_default().get_commands().setState({
                    "pd/document-type": {
                        documentType: documentType
                    }
                });

            },
            dblclick: function (e) {
                PD.context.get_default().get_commands().execute("pd/document-type:document-type/edit-dialog");
            },
            contextMenu: {
                type: "PD.Manage.Modules.DocumentTypesContextMenu",
                context: function () {
                    return {
                        viewGrid: that._grid,
                        item: that._grid.getSelection()
                    };
                }
            }
        });

        this.get_children().add(this._grid);

    },

    _toolbar_init: function () {

        var that = this,
            grid = this._grid;

        this._toolbar = new PD.Web.UI.Controls.Toolbar({
            insertAt: "[data-id=toolbar]",
            segments: [
              new PD.Manage.Modules.DocumentTypesToolbar(function () {
                    return {
                        viewGrid: grid,
                        item: grid.getSelection(),
                        entityTypeId: that.data("entityTypeId")
                    };
              })
            ]
        });

        this.get_children().add(this._toolbar);

    }

});